unit Camain;

interface

uses
  SysUtils, WinTypes, WinProcs, Forms, Messages, StdCtrls, Dialogs, Classes, Controls,
  Menus, FileCtrl,
  Alchemw, Caexcomm, Causer;

type
  TMAIN = class(TForm)
    ListBox: TListBox;
    MainMenu: TMainMenu;
    MyMenu: TMenuItem;
    WAICONS: TMenuItem;
    WCASCADE: TMenuItem;
    WTILE: TMenuItem;
    Break1: TMenuItem;
    procedure WAICONSClick(Sender: TObject);
    procedure WTILEClick(Sender: TObject);
    procedure WCASCADEClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
    mDEBUGSTATE:          Integer;
  end;

var
  MAIN: TMAIN;

type CADataStruct = Record
        fFileSent:        BOOL;
        fHOSTUSER:        THOSTUSER;
     end;

procedure PlugActivate(SlotH: LPSLOT; activate: BOOL); export;
procedure PlugPaint(SlotH: LPSLOT; dc: HDC; erase: BOOL; var rect: TRECT); export;
procedure PlugResize(SlotH: LPSLOT; width, height: WORD); export;
function  PlugDialog(SlotH: LPSLOT; uResult: WORD):WORD; export;
function  PlugData(SlotH: LPSLOT; more: BOOL; data: LPVOID):BOOL; export;
function  PlugUnique(SlotH: LPSLOT; args, cMessage: PChar):BOOL; export;
procedure PlugDestroy(SlotH: LPSLOT); export;
function  PlugButton(SlotH: LPSLOT; id: WORD):WORD; export;
function  PlugMouse(SlotH: LPSLOT; code: BYTE; x, y: WORD):BOOL; export;
function  PlugType(SlotH: LPSLOT; title: PChar):WORD; export;
function  PlugProcess(SlotH: LPSLOT):WORD; export;
function  PlugDLLSize(SlotH: LPSLOT):LongInt; export;
function  PlugNextDLL(SlotH: LPSLOT; name: PChar; limit: WORD; dest: PChar;
          dlim: WORD):BOOL; export;
function  PlugDLLVerify(SlotH: LPSLOT; curOS: LongInt; info: Pointer;
          company, intern, ver, descript: PChar ):WORD; export;
function  PlugCommand(SlotH: LPSLOT; cCMD: Pointer; cLen: WORD):WORD; export;

implementation

{$R *.DFM}
procedure PlugActivate(SlotH: LPSLOT; activate: BOOL);
begin
end;

procedure PlugPaint(SlotH: LPSLOT; dc: HDC; erase: BOOL; var rect: TRECT);
begin
end;

procedure PlugResize(SlotH: LPSLOT; width, height: WORD);
begin
end;

function  PlugDialog(SlotH: LPSLOT; uResult: WORD):WORD;
begin
     Result := AL_OK;
end;

function  PlugData(SlotH: LPSLOT; more: BOOL; data: LPVOID):BOOL;
begin
     Result := TRUE;
end;

function  PlugUnique(SlotH: LPSLOT; args, cMessage: PChar):BOOL;
begin
     Result := TRUE;
end;

procedure PlugDestroy(SlotH: LPSLOT);
var ds: ^CADataStruct;
begin
     ds := AlLock(SlotH);

     MAIN.ListBox.Items.Add( ds^.fHOSTUSER.uUSERLNAME+' :LogOut');
     ds^.fHOSTUSER.Release;

     AlFree(SlotH);
end;

function  PlugButton(SlotH: LPSLOT; id: WORD):WORD;
begin
     Result := AL_IDLE;
end;

function  PlugMouse(SlotH: LPSLOT; code: BYTE; x, y: WORD):BOOL;
begin
     Result := BOOL(AL_IDLE);
end;

function  PlugType(SlotH: LPSLOT; title: PChar):WORD;
var ds: ^CADataStruct;
    lSA: array[0..255] of Char;
begin
     if not assigned(MAIN) then
        begin
             Application.CreateForm( TMAIN, MAIN );
             MAIN.Show;
        end;

     AlAlloc(SlotH, sizeof(CADataStruct));
     ds := AlLock(SlotH);
     ds^.fFileSent := FALSE;

     ds^.fHOSTUSER := THOSTUSER.Create( Application );
     ds^.fHOSTUSER.Show;

     AlGetSysUserDir(SlotH, lSA, 81);
     ds^.fHOSTUSER.uUSERDIR := StrPas(lSA) + '\CATALOG\HOST';

     ForceDirectories(ds^.fHOSTUSER.uUSERDIR);

     AlGetUserLast(SlotH, lSA, 26);
     ds^.fHOSTUSER.uUSERLNAME := StrPas(lSA);
     ds^.fHOSTUSER.Caption    := 'USER: ['+StrPas(lSA)+']';

     randomize;
     ds^.fHOSTUSER.uUSERTFILE := 'U-'+IntToStr(random(999))+'S'+IntToStr(random(50));

     MAIN.ListBox.Items.Add( ds^.fHOSTUSER.uUSERLNAME+' :LogIn');
     ds^.fHOSTUSER.ListBox.Items.Add( 'LogIn' );
     ds^.fHOSTUSER.ListBox.Items.Add( 'WDir: '+ds^.fHOSTUSER.uUSERDIR );
     ds^.fHOSTUSER.ListBox.Items.Add( 'TFileID: '+ds^.fHOSTUSER.uUSERTFILE );
     AlUnlock(SlotH);

     StrPCopy( title, 'EXSAMPLE.DLL');
     Result := AL_WIN_PLUGIN;
end;

function  PlugProcess(SlotH: LPSLOT):WORD;
var pState: WORD;
    ds: ^CADataStruct;
begin
     ds := AlLock(SlotH);
     pState := AlGetState(SlotH);

     case pState of
          CA_IDLE: begin
                        MAIN.ListBox.Items.Add( ds^.fHOSTUSER.uUSERLNAME+': CA: PlugProcess: State=CA_IDLE');
                        Result := AL_IDLE;
                        AlUnlock(SlotH);
                        Exit;
                   end;
          CA_DONE: begin
                        MAIN.ListBox.Items.Add( ds^.fHOSTUSER.uUSERLNAME+': CA: PlugProcess: State=CA_DONE');
                        Result := AL_DIE;
                        AlUnlock(SlotH);
                        Exit;
                   end;
     end;

     AlUnlock(SlotH);
     Result := AL_IDLE;
end;

function  PlugDLLSize(SlotH: LPSLOT):LongInt;
var pFileSize: LongInt;
    pFile: file of BYTE;
    ds: ^CADataStruct;
begin
     ds := AlLock(SlotH);

     MAIN.ListBox.Items.Add( ds^.fHOSTUSER.uUSERLNAME+': CA: PlugDLLSize');
     AssignFile(pFile,'EXSAMPLE.DLL');
     Reset(pFile);
     pFileSize := FileSize(pFile);
     CloseFile(pFile);

     AlUnlock(SlotH);

     Result := pFileSize;
end;

function  PlugNextDLL(SlotH: LPSLOT; name: PChar; limit: WORD; dest: PChar;
          dlim: WORD):BOOL;
var ds: ^CADataStruct;
begin
     ds := AlLock(SlotH);

     if ds^.fFileSent = FALSE then
        begin
             StrPCopy( name, 'EXSAMPLE.DLL' );
             StrPCopy( dest, 'EXSAMPLE.DLL' );

             ds^.fFileSent := TRUE;
             MAIN.ListBox.Items.Add( ds^.fHOSTUSER.uUSERLNAME+': CA: PlugNextDLL :dll being sent');
             AlUnlock(SlotH);
             Result := TRUE;
        end
        else
            begin
                 StrPCopy( name, '' );
                 StrPCopy( dest, '' );

                 MAIN.ListBox.Items.Add( ds^.fHOSTUSER.uUSERLNAME+': CA: PlugNextDLL :no more dll');
                 AlUnlock(SlotH);
                 Result := FALSE;
            end;
end;

function  PlugDLLVerify(SlotH: LPSLOT; curOS: LongInt; info: Pointer;
          company, intern, ver, descript: PChar ):WORD;
var fSend: BOOL;
    pEMPTY: array[0..10] of Char;
    ds: ^CADataStruct;
begin
     ds := AlLock(SlotH);
     MAIN.ListBox.Items.Add( ds^.fHOSTUSER.uUSERLNAME+': CA: PlugDLLVerify' );

     fSend := FALSE;
     StrPCopy(pEMPTY, '');

     if (StrComp(company, pEMPTY) = 0) or (StrComp(intern, pEMPTY) = 0)   or
        (StrComp(ver, pEMPTY) = 0)     or (StrComp(descript, pEMPTY) = 0) then
        fSend := TRUE;

     if fSend = TRUE then
        begin
             StrPCopy( company,  'PC Net/Com.');
             StrPCopy( intern,   'Sample Excalibur DLL');
             StrPCopy( ver,      '1.0');
             StrPCopy( descript, 'EXSAMPLE');

             Result := NODLL_NONE;
        end
        else
            begin
                 Result := NODLL_OK;
            end;

     AlUnlock(SlotH);
end;

function  PlugCommand(SlotH: LPSLOT; cCMD: Pointer; cLen: WORD):WORD;
var lI: Integer;
    od: CommandData;
    td: ^CommandData;
    ds: ^CADataStruct;
    BufS: String;
begin
     ds := AlLock(SlotH);
     td := cCMD;

     case td^.cSTATE of
          CA_IDLE:   begin
                          MAIN.ListBox.Items.Add( ds^.fHOSTUSER.uUSERLNAME+': CA: PlugCommand: State=CA_IDLE' );
                          od.cControlByte := 1;
                          od.cSTATE := EX_START;

                          AlAddBlock(SlotH,@od,3);
                          AlSetState(SlotH,CA_IDLE);
                     end;
          CA_DONE:   begin
                          MAIN.ListBox.Items.Add( ds^.fHOSTUSER.uUSERLNAME+': CA: PlugCommand: State=CA_DONE' );
                          od.cControlByte := 1;
                          od.cSTATE := EX_DONE;

                          AlAddBlock(SlotH,@od,3);
                          AlSetState(SlotH,CA_DONE);
                     end;
          CA_INFO:   begin
                          FmtStr(BufS, '%s %s', [': EX: ', StrPas(td^.cDATA)]);
                          MAIN.ListBox.Items.Add( ds^.fHOSTUSER.uUSERLNAME+BufS);
                     end;
     end;

     AlUnlock(SlotH);
     Result := AL_OK;
end;

procedure TMAIN.WAICONSClick(Sender: TObject);
begin
     ArrangeIcons;
end;

procedure TMAIN.WTILEClick(Sender: TObject);
begin
     Tile;
end;

procedure TMAIN.WCASCADEClick(Sender: TObject);
begin
     Cascade;
end;

procedure TMAIN.FormCreate(Sender: TObject);
begin
     WindowMenu := MyMenu;
end;

procedure TMAIN.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     Action := caNONE;
end;

end.
