unit Exmain;

interface

uses
  SysUtils, WinTypes, WinProcs, Forms, Messages, StdCtrls, Classes, Controls,
  Dialogs, FileCtrl,
  Exlib, Caexcomm, Exuser;


type
  TMAIN = class(TForm)
    ListBox: TListBox;
    MBEXIT: TButton;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure MBEXITClick(Sender: TObject);
  private
    { Private declarations }
    ZUSER:                      TZUSER;
    pWND, pCHILD, pWNDCHILD:    HWND;
    pLIBH:                      EXLIBH;
    pMAXIMIZED, pDOWNLOADED:    BOOL;
    pSTATUS:                    String[255];
    pDEBUGSTATE:                Integer;
  public
    { Public declarations }
    procedure SendDebug(sdTEXT: String);
  end;

var MAIN: TMAIN;

function  PlugInit(LibH: EXLIBH; iARGS: PChar): WORD; export;
procedure PlugDestroy(LibH: EXLIBH); export;
function  PlugCommand(LibH: EXLIBH; cCMD: Pointer; cLEN: WORD): WORD; export;
function  PlugProcess(LibH: EXLIBH): WORD; export;

implementation
{$R *.DFM}

{EXPORTED FUNCTIONS}
function PlugInit(LibH: EXLIBH; iARGS: PChar): WORD;
var sTEMP: String[81];
    dwRESULT: LONGINT;
begin
     if not assigned(MAIN) then
        begin
             Application.CreateForm( TMAIN, MAIN );
             MAIN.Show;

             MAIN.ZUSER := TZUSER.Create( Application );
             MAIN.ZUSER.Show;
        end;

     ExSetPtr(LibH, MAIN);

     MAIN.pLIBH := LibH;
     MAIN.pDOWNLOADED := TRUE;

     GetDir( 0, MAIN.ZUSER.pUSERDIR );
     MAIN.ZUSER.pUSERDIR := MAIN.ZUSER.pUSERDIR + '\CATALOG\USER';
     ForceDirectories( MAIN.ZUSER.pUSERDIR );
     MAIN.ListBox.Items.Add('WDir: '+MAIN.ZUSER.pUSERDIR);

     MAIN.pWND := ExMDIClient( LibH );
     dwRESULT := SendMessage(MAIN.pWND, WM_MDIGETACTIVE, 0, LONGINT(0) );
     MAIN.pWNDCHILD := HWND(LOWORD(dwRESULT));
     MAIN.pMAXIMIZED := BOOL(HIWORD(dwRESULT));
     SendMessage(MAIN.pWNDCHILD,WM_GETTEXT, 80, LONGINT(@sTEMP) );
     FmtStr( MAIN.pSTATUS, '%s%s', ['Connected to ',sTemp] );

     MAIN.ZUSER.pSTATE := EX_INIT;

     MAIN.SendDebug('Ex: PlugInit');
     PlugInit := AL_OK;
end;

procedure PlugDestroy(LibH: EXLIBH);
var MAIN: TMAIN;
begin
     MAIN := ExGetPtr(LibH);
     MAIN.SendDebug('EX: PlugDestroy');
end;

function PlugCommand(LibH: EXLIBH; cCMD: Pointer; cLEN: WORD): WORD;
var lI: Integer;
    MAIN: TMAIN;
    lOD: ^CommandData;
begin
     MAIN := ExGetPtr(LibH);
     lOD  := cCMD;

     MAIN.SendDebug('EX: PlugCommand');

     case lOD^.cSTATE of
          EX_START:  begin
                          MAIN.SendDebug('EX: PlugCommand: EX_START');
                          MAIN.ListBox.Items.Add('PlugCommand: EX_START');
                          MAIN.ZUSER.pSTATE := EX_START;
                          PlugCommand := AL_OK;
                     end;
          EX_DONE:   begin
                          MAIN.SendDebug('EX: PlugCommand: EX_DONE');
                          MAIN.ListBox.Items.Add('PlugCommand: EX_DONE');
                          PlugCommand := AL_DIE;
                     end;
          else
              PlugCommand := AL_OK;
     end;
end;

function  PlugProcess(LibH: EXLIBH): WORD;
var MAIN: TMAIN;
begin
     MAIN := ExGetPtr(LibH);
     MAIN.ZUSER.pOD.cControlByte := 1;

     case MAIN.ZUSER.pSTATE of
          EX_INIT:    begin
                           MAIN.SendDebug('EX: PlugProcess: EX_INIT');
                           MAIN.ListBox.Items.Add('PlugProcess: EX_INIT');
                           MAIN.ZUSER.pOD.cSTATE := CA_IDLE;
                           ExAddBlock(LibH, @MAIN.ZUSER.pOD, 3);
                           MAIN.ZUSER.pSTATE := EX_IDLE;
                           PlugProcess := AL_IDLE;
                      end;
          EX_START:   begin
                           MAIN.SendDebug('EX: PlugProcess: EX_START');
                           MAIN.ListBox.Items.Add('PlugProcess: EX_START');
                           MAIN.ZUSER.pSTATE := EX_IDLE;
                           PlugProcess := AL_IDLE;
                      end;
          EX_IDLE:    begin
                           PlugProcess := AL_IDLE;
                      end;
          EX_CLOSE:   begin
                           MAIN.SendDebug('EX: PlugProcess: EX_CLOSE');
                           MAIN.ListBox.Items.Add('PlugProcess: EX_CLOSE');
                           MAIN.ZUSER.pOD.cSTATE := CA_DONE;
                           ExAddBlock(LibH, @MAIN.ZUSER.pOD, 3);
                           MAIN.ZUSER.pSTATE := EX_IDLE;
                           PlugProcess := AL_IDLE;
                      end;
          else
              PlugProcess := AL_IDLE;
     end;

end;

procedure TMAIN.SendDebug(sdTEXT: String);
var nLEN: Integer;
begin
     ZUSER.pOD.cControlByte := 1;
     ZUSER.pOD.cSTATE := CA_INFO;
     StrPCopy(ZUSER.pOD.cDATA, sdTEXT );
     ExAddBlock(pLIBH, @ZUSER.pOD, length(ZUSER.pOD.cDATA));
end;

procedure TMAIN.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     Action := caNONE;
end;

procedure TMAIN.MBEXITClick(Sender: TObject);
begin
     ZUSER.pSTATE := EX_CLOSE;
end;

end.
